Index: package_tags/sipb-xen-base/2/sipb-xen-base/debian/changelog
===================================================================
--- package_tags/sipb-xen-base/2/sipb-xen-base/debian/changelog	(revision 55)
+++ package_tags/sipb-xen-base/2/sipb-xen-base/debian/changelog	(revision 55)
@@ -0,0 +1,12 @@
+sipb-xen-base (2) unstable; urgency=low
+
+  * Update sources.list to include our debian mirror
+
+ -- Sam Hartman <hartmans@debian.org>  Sat,  4 Aug 2007 19:11:18 -0400
+
+sipb-xen-base (1) unstable; urgency=low
+
+  * New upstream version
+
+ -- Sam Hartman <hartmans@debian.org>  Sat,  4 Aug 2007 18:44:21 -0400
+
Index: package_tags/sipb-xen-base/2/sipb-xen-base/debian/compat
===================================================================
--- package_tags/sipb-xen-base/2/sipb-xen-base/debian/compat	(revision 55)
+++ package_tags/sipb-xen-base/2/sipb-xen-base/debian/compat	(revision 55)
@@ -0,0 +1,1 @@
+4
Index: package_tags/sipb-xen-base/2/sipb-xen-base/debian/control
===================================================================
--- package_tags/sipb-xen-base/2/sipb-xen-base/debian/control	(revision 55)
+++ package_tags/sipb-xen-base/2/sipb-xen-base/debian/control	(revision 55)
@@ -0,0 +1,14 @@
+Source: sipb-xen-base
+Section: base
+Priority: extra
+Maintainer: SIPB Xen Project <sipb-xen@mit.edu>
+Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 4.1.0)
+Standards-Version: 3.7.2
+
+Package: sipb-xen-base
+Architecture: all
+Depends: ${misc:Depends}, 
+Description: Base configuration required for all SIPB xen servers
+ This package includes apt configuration, .k5login and other files that
+ should be synchronized among all our servers.
+ Installing this on a non-sipb-xen machine would be very anti-social.
Index: package_tags/sipb-xen-base/2/sipb-xen-base/debian/copyright
===================================================================
--- package_tags/sipb-xen-base/2/sipb-xen-base/debian/copyright	(revision 55)
+++ package_tags/sipb-xen-base/2/sipb-xen-base/debian/copyright	(revision 55)
@@ -0,0 +1,3 @@
+This package was created for internal use of the SIPB Xen Project of
+the MIT Student Information Processing Board.  Ask tabbott@mit.edu if
+you have questions about redistribution.
Index: package_tags/sipb-xen-base/2/sipb-xen-base/debian/rules
===================================================================
--- package_tags/sipb-xen-base/2/sipb-xen-base/debian/rules	(revision 55)
+++ package_tags/sipb-xen-base/2/sipb-xen-base/debian/rules	(revision 55)
@@ -0,0 +1,4 @@
+#!/usr/bin/make -f
+
+
+include /usr/share/cdbs/1/rules/debhelper.mk
Index: package_tags/sipb-xen-base/2/sipb-xen-base/debian/sipb-xen-base.install
===================================================================
--- package_tags/sipb-xen-base/2/sipb-xen-base/debian/sipb-xen-base.install	(revision 55)
+++ package_tags/sipb-xen-base/2/sipb-xen-base/debian/sipb-xen-base.install	(revision 55)
@@ -0,0 +1,1 @@
+files/* .
Index: package_tags/sipb-xen-base/2/sipb-xen-base/files/etc/apt/sources.list
===================================================================
--- package_tags/sipb-xen-base/2/sipb-xen-base/files/etc/apt/sources.list	(revision 55)
+++ package_tags/sipb-xen-base/2/sipb-xen-base/files/etc/apt/sources.list	(revision 55)
@@ -0,0 +1,6 @@
+deb http://sipb-vm-1.mit.edu/debian stable main
+
+deb http://sipb-vm-1.mit.edu/sipb-xen stable main
+
+deb-src http://debian.lcs.mit.edu/debian  etch main
+deb http://debian.lcs.mit.edu/debian etch main
Index: package_tags/sipb-xen-base/2/sipb-xen-base/files/root/.k5login
===================================================================
--- package_tags/sipb-xen-base/2/sipb-xen-base/files/root/.k5login	(revision 55)
+++ package_tags/sipb-xen-base/2/sipb-xen-base/files/root/.k5login	(revision 55)
@@ -0,0 +1,22 @@
+hartmans@ATHENA.MIT.EDU
+hartmans/root@ATHENA.MIT.EDU
+jbarnold@ATHENA.MIT.EDU
+jbarnold/root@ATHENA.MIT.EDU
+andersk@ATHENA.MIT.EDU
+andersk/root@ATHENA.MIT.EDU
+nelhage@ATHENA.MIT.EDU
+nelhage/root@ATHENA.MIT.EDU
+tabbott@ATHENA.MIT.EDU
+tabbott/root@ATHENA.MIT.EDU
+asedeno@ATHENA.MIT.EDU
+asedeno/root@ATHENA.MIT.EDU
+quentin@ATHENA.MIT.EDU
+quentin/root@ATHENA.MIT.EDU
+danjared@ATHENA.MIT.EDU
+danjared/root@ATHENA.MIT.EDU
+ecprice@ATHENA.MIT.EDU
+ecprice/root@ATHENA.MIT.EDU
+zev@ATHENA.MIT.EDU
+zev/root@ATHENA.MIT.EDU
+mclamb@ATHENA.MIT.EDU
+mclamb/root@ATHENA.MIT.EDU