Index: trunk/web/templates/main.py
===================================================================
--- trunk/web/templates/main.py	(revision 152)
+++ trunk/web/templates/main.py	(revision 153)
@@ -13,6 +13,7 @@
 import hmac
 import datetime
-
-sys.stderr = sys.stdout
+import StringIO
+
+sys.stderr = StringIO.StringIO()
 sys.path.append('/home/ecprice/.local/lib/python2.5/site-packages')
 
@@ -32,5 +33,8 @@
     the select box).
     """
-    pass
+    def __init__(self, err_field, err_value, expl=None):
+        super(InvalidInput, self).__init__(expl)
+        self.err_field = err_field
+        self.err_value = err_value
 
 class CodeError(MyException):
@@ -116,8 +120,16 @@
     return machine.owner == user.username
 
-def error(op, user, fields, err):
+def error(op, user, fields, err, emsg):
     """Print an error page when a CodeError occurs"""
-    d = dict(op=op, user=user, errorMessage=str(err))
-    print Template(file='error.tmpl', searchList=[d, global_dict]);
+    d = dict(op=op, user=user, errorMessage=str(err),
+             stderr=emsg)
+    return Template(file='error.tmpl', searchList=[d, global_dict]);
+
+def invalidInput(op, user, fields, err, emsg):
+    """Print an error page when an InvalidInput exception occurs"""
+    d = dict(op=op, user=user, err_field=err.err_field,
+             err_value=str(err.err_value), stderr=emsg,
+             errorMessage=str(err))
+    return Template(file='invalid.tmpl', searchList=[d, global_dict]);
 
 def validMachineName(name):
@@ -266,9 +278,11 @@
     try:
         if memory > maxMemory(user):
-            raise InvalidInput("Too much memory requested")
+            raise InvalidInput('memory', memory,
+                               "Max %s" % maxMemory(user))
         if disk > maxDisk(user) * 1024:
-            raise InvalidInput("Too much disk requested")
+            raise InvalidInput('disk', disk,
+                               "Max %s" % maxDisk(user))
         if not canAddVm(user):
-            raise InvalidInput("Too many VMs requested")
+            raise InvalidInput('create', True, 'Unable to create more VMs')
         res = meta.engine.execute('select nextval(\'"machines_machine_id_seq"\')')
         id = res.fetchone()[0]
@@ -312,8 +326,9 @@
             raise ValueError
     except ValueError:
-        raise InvalidInput("Invalid memory amount; must be at least %s MB" %
-                          MIN_MEMORY_SINGLE)
+        raise InvalidInput('memory', memory, 
+                           "Minimum %s MB" % MIN_MEMORY_SINGLE)
     if memory > maxMemory(user, machine):
-        raise InvalidInput("Too much memory requested")
+        raise InvalidInput('memory', memory,
+                           'Maximum %s MB' % maxMemory(user, machine))
     return memory
 
@@ -323,11 +338,12 @@
         disk = float(disk)
         if disk > maxDisk(user, machine):
-            raise InvalidInput("Too much disk requested")
+            raise InvalidInput('disk', disk,
+                               "Maximum %s G" % maxDisk(user, machine))
         disk = int(disk * 1024)
         if disk < MIN_DISK_SINGLE * 1024:
             raise ValueError
     except ValueError:
-        raise InvalidInput("Invalid disk amount; minimum is %s GB" %
-                          MIN_DISK_SINGLE)
+        raise InvalidInput('disk', disk,
+                           "Minimum %s GB" % MIN_DISK_SINGLE)
     return disk
 
@@ -336,9 +352,10 @@
     name = fields.getfirst('name')
     if not validMachineName(name):
-        raise InvalidInput("Invalid name '%s'" % name)
+        raise InvalidInput('name', name)
     name = user.username + '_' + name.lower()
 
     if Machine.get_by(name=name):
-        raise InvalidInput("A machine named '%s' already exists" % name)
+        raise InvalidInput('name', name,
+                           "Already exists")
     
     memory = fields.getfirst('memory')
@@ -360,5 +377,5 @@
     d = dict(user=user,
              machine=machine)
-    print Template(file='create.tmpl',
+    return Template(file='create.tmpl',
                    searchList=[d, global_dict]);
 
@@ -392,5 +409,5 @@
              uptimes=uptimes,
              cdroms=CDROM.select())
-    print Template(file='list.tmpl', searchList=[d, global_dict])
+    return Template(file='list.tmpl', searchList=[d, global_dict])
 
 def testMachineId(user, machineId, exists=True):
@@ -453,5 +470,5 @@
              hostname=os.environ.get('SERVER_NAME', 'localhost'),
              authtoken=token)
-    print Template(file='vnc.tmpl',
+    return Template(file='vnc.tmpl',
                    searchList=[d, global_dict])
 
@@ -530,5 +547,6 @@
     elif action == 'Power on':
         if maxMemory(user) < machine.memory:
-            raise InvalidInput("You don't have enough free RAM quota")
+            raise InvalidInput('action', 'Power on',
+                               "You don't have enough free RAM quota to turn on this machine")
         bootMachine(machine, cdrom)
     elif action == 'Power off':
@@ -543,11 +561,43 @@
              command=action,
              machine=machine)
-    print Template(file="command.tmpl", searchList=[d, global_dict])
-        
+    return Template(file="command.tmpl", searchList=[d, global_dict])
+
+def testOwner(user, owner, machine=None):
+    if owner != user.username:
+        raise InvalidInput('owner', owner,
+                           "Invalid")
+    return owner
+
+def testContact(user, contact, machine=None):
+    if contact != user.email:
+        raise InvalidInput('contact', contact,
+                           "Invalid")
+    return contact
+
+def testHostname(user, hostname, machine):
+    for nic in machine.nics:
+        if hostname == nic.hostname:
+            return hostname
+    raise InvalidInput('hostname', hostname,
+                       "Different from before")
+
+
 def modify(user, fields):
     """Handler for modifying attributes of a machine."""
     #XXX not written yet
     machine = testMachineId(user, fields.getfirst('machine_id'))
-    
+    owner = testOwner(user, fields.getfirst('owner'), machine)
+    contact = testContact(user, fields.getfirst('contact'))
+    hostname = testHostname(user, fields.getfirst('hostname'),
+                            machine)
+    ram = fields.getfirst('memory')
+    if ram is not None:
+        ram = validMemory(user, ram, machine)
+    disk = testDisk(user, fields.getfirst('disk'))
+    if disk is not None:
+        disk = validDisk(user, disk, machine)
+
+    
+
 def help(user, fields):
     """Handler for help messages."""
@@ -570,5 +620,5 @@
              mapping=mapping)
     
-    print Template(file="help.tmpl", searchList=[d, global_dict])
+    return Template(file="help.tmpl", searchList=[d, global_dict])
     
 
@@ -645,5 +695,5 @@
              max_disk=max_disk,
              fields = fields)
-    print Template(file='info.tmpl',
+    return Template(file='info.tmpl',
                    searchList=[d, global_dict])
 
@@ -686,14 +736,33 @@
         operation = 'list'
     
-    fun = mapping.get(operation, 
-                      lambda u, e:
-                          error(operation, u, e,
-                                "Invalid operation '%s'" % operation))
+    def badOperation(u, e):
+        raise CodeError("Unknown operation")
+
+    fun = mapping.get(operation, badOperation)
     if fun not in (help, ):
         connect('postgres://sipb-xen@sipb-xen-dev/sipb_xen')
     try:
-        fun(u, fields)
+        output = fun(u, fields)
+        print 'Content-Type: text/html\n'
+        sys.stderr.seek(0)
+        e = sys.stderr.read()
+        if e:
+            output = output.replace('<body>', '<body><pre>'+e+'</pre>')
+        print output
     except CodeError, err:
-        error(operation, u, fields, err)
+        print 'Content-Type: text/html\n'
+        sys.stderr.seek(0)
+        e = sys.stderr.read()
+        print error(operation, u, fields, err, e)
     except InvalidInput, err:
-        error(operation, u, fields, err)
+        print 'Content-Type: text/html\n'
+        sys.stderr.seek(0)
+        e = sys.stderr.read()
+        print invalidInput(operation, u, fields, err, e)
+    except:
+        print 'Content-Type: text/plain\n'
+        sys.stderr.seek(0)
+        e = sys.stderr.read()
+        print e
+        print '----'
+        raise